{#-#####################################################################
 # Jinja2 template for /etc/rc.conf.d/netif
 #======================================================================
 # Helper macros for the FreeBSD rc network framework
 ####################################################################-#}
{#======================================================================
 # Format inet address
 #----------------------------------------------------------------------
 # This macro formats a static inet address definition to a string
 # compatible with ifconfig commands. The formatted string is echoed
 # back, unless the address definition is invalid.
 #
 # The formatted string is built in the form of:
 #    <address> netmask <netmask>[ broadcast <broadcast>]
 #
 # If the ``main_address_def`` parameter is supplied, the macro will
 # ensure the echoed main address uses a non-conflicting subnet.
 #===================================================================-#}
{%- macro format_inet_address(address_def, main_address_def=None) -%}
  {%- set options = [] -%}

  {#- Build address strings -#}
  {%- set address_string =
      address_def['address'] ~ '/' ~ address_def['length'] -%}
  {%- set address =
      address_string | ipv4('host/prefix') | ipaddr('address') -%}
  {%- set netmask =
      address_string | ipv4('host/prefix') | ipaddr('netmask') |
      ip4_hex -%}

  {#- Store IPv4 address string -#}
  {{ options.append(address) }}

  {#- If main_address_def is specified, it means we're formatting the
   #  address of an inet alias. We must check whether a non-conflicting
   #  subnet is required for this alias. -#}
  {%- if main_address_def -%}
    {#- Normalize the main address -#}
    {%- set main_address_string =
        main_address_def['address'] ~ '/' ~
        main_address_def['length'] -%}
    {%- set main_address = main_address_string | ipv4('host/prefix') -%}

    {#- Check whether the addr is in the same subnet as main addr -#}
    {%- if address | ipaddr(main_address) -%}
      {%- set netmask = "ffffffff" -%}
    {%- endif -%}
  {%- endif -%}

  {#- Store IPv4 netmask string -#}
  {{ options.append('netmask ' ~ '0x' ~ netmask) }}

  {#- Optional static broadcast address -#}
  {%- if 'broadcast' in address_def -%}
    {%- set broadcast_string =
        address_def['broadcast'] ~ '/' ~ address_def['length'] -%}
    {%- set broadcast =
        broadcast_string | ipv4('host/prefix') | ipaddr('address') -%}
    {{ options.append('broadcast ' ~ broadcast) }}
  {%- endif -%}

  {#- Format the address -#}
  {%- if options -%}
    {{ options | join(" ") }}
  {%- endif -%}
{%- endmacro -%}

{#======================================================================
 # Format inet6 address
 #----------------------------------------------------------------------
 # This macro formats a static inet6 address definition to a string
 # compatible with ifconfig commands. The formatted string is echoed
 # back, unless the address definition is invalid.
 #
 # The formatted string is built in the form of:
 #    <address> prefixlen <prefix_length>[ anycast]
 #
 # If the ``main_address_def`` parameter is supplied, the macro will
 # ensure the echoed main address uses a non-conflicting subnet.
 #===================================================================-#}
{%- macro format_inet6_address(address_def, main_address_def=None) -%}
  {%- set options = [] -%}

  {#- Build address strings -#}
  {%- set address_string =
      address_def['address'] ~ '/' ~ address_def['length'] -%}
  {%- set address =
      address_string | ipv6('host/prefix') | ipaddr('address') -%}
  {%- set prefix_length =
      address_string | ipv6('host/prefix') | ipaddr('prefix') -%}

  {#- Store IPv6 address string -#}
  {{ options.append(address) }}

  {#- If main_address_def is specified, it means we're formatting the
   #  address of an inet6 alias. We must check whether a non-conflicting
   #  subnet is required for this alias. -#}
  {%- if main_address_def -%}
    {#- Normalize the main address -#}
    {%- set main_address_string =
        main_address_def['address'] ~ '/' ~
        main_address_def['length'] -%}
    {%- set main_address = main_address_string | ipv6('host/prefix') -%}

    {#- Check whether the addr is in the same subnet as main addr -#}
    {%- if address | ipaddr(main_address) -%}
      {%- set prefix_length = "128" -%}
    {%- endif -%}
  {%- endif -%}

  {#- Store IPv6 prefix length -#}
  {{ options.append('prefixlen ' ~ prefix_length) }}

  {#- Optional anycast address -#}
  {%- if 'anycast' in address_def and address_def['anycast'] == true -%}
    {{ options.append('anycast') }}
  {%- endif -%}

  {#- Format the address -#}
  {%- if options -%}
    {{ options | join(" ") }}
  {%- endif -%}
{%- endmacro -%}

{#======================================================================
 # Format rc variable
 #----------------------------------------------------------------------
 # This macro is responsible for rendering a single rc variable using
 # the constraints common to the rc.conf file format.
 #
 # Parameters:
 #   - name   (str)             Name or the rc variable to render
 #   - value  (str or str[])    Value of the rc variable to render. If
 #                              a list is supplied, each list item shall
 #                              be rendered on a single line, with auto-
 #                              matic escaping.
 #   - comment (str, optional)  Optional comment to show above rendered
 #                              lines.
 #===================================================================-#}
{%- macro format_rc_var(name, value, comment=None) -%}
  {%- if name and value and (value is string or value is iterable) -%}

    {%- if comment -%}
      {{ "# " ~ comment ~ "\n" }}
    {%- endif -%}

    {{ name ~ "=" }}

    {%- if value is string -%}
      {{ '"' ~ value ~ '"' ~ "\n" }}
    {%- elif value is iterable -%}
      {{ '"\\\n\t' ~ value | join(" \\\n\t") ~ '"' ~ "\n" }}
    {%- endif -%}

  {%- endif -%}
{%- endmacro -%}
